//package com.lm.lib.controller;
//
//import com.google.gson.Gson;
//import com.lm.lib.dto.AlarmMapDto;
//import com.lm.lib.param.*;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
//import io.swagger.annotations.ApiParam;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.http.HttpEntity;
//import org.apache.http.client.methods.HttpGet;
//import org.apache.http.impl.client.HttpClients;
//import org.apache.http.util.EntityUtils;
//import org.springframework.dao.EmptyResultDataAccessException;
//import org.springframework.jdbc.core.JdbcTemplate;
//import org.springframework.util.ObjectUtils;
//import org.springframework.util.StringUtils;
//import org.springframework.web.bind.annotation.RequestMapping;
//import org.springframework.web.bind.annotation.RequestMethod;
//import org.springframework.web.bind.annotation.RestController;
//
//import javax.annotation.Resource;
//import java.io.IOException;
//import java.text.SimpleDateFormat;
//import java.util.*;
//
//@Api(tags = {"大屏页面"})
//@Slf4j
//@RestController
//@RequestMapping("/showData")
//public class ShowDataVController {
//
//    @Resource(name = "iotpJdbcTemplate")
//    JdbcTemplate iotpJdbcTemplate;
//
//    @Resource(name = "qxcasJdbcTemplate")
//    JdbcTemplate qxcasJdbcTemplate;
//
//    @Resource(name = "moyuJdbcTemplate")
//    JdbcTemplate moyuJdbcTemplate;
//
////    @Autowired
////    StoreClient storeClient;
////    StoreApi service = new StoreBindProxy();
////    StoreClient storeClient = new StoreClient(service);
//
//    @ApiOperation(value = "基本信息")
//    @RequestMapping(value = "/baseInfo", method = RequestMethod.GET)
//    public RspBaseInfo baseInfo(@ApiParam(name = "查询参数", value = "sn号", required = false) String sn) throws IOException {
//        RspBaseInfo rspBaseInfo = new RspBaseInfo();
//        List<String> timeList = new ArrayList<>();
//        List<Double> voltageMaxList = new ArrayList<>();
//        List<Double> voltageMinList = new ArrayList<>();
//        List<Double> tempMaxList = new ArrayList<>();
//        List<Double> tempMinList = new ArrayList<>();
//        List<Double> currentList = new ArrayList<>();
//        List<Double> socList = new ArrayList<>();
//
//        HttpEntity httpEntity;
//        if (StringUtils.hasLength(sn)) {
//
////
////            // 必要参数
////            StoreIterable<DataPackage> it = storeClient.load(sn).dataType(12);
////            Date date = new Date();
////            Long fromTs = Safe.getTimestamp(new SimpleDateFormat("yyyy-MM-dd 00:00:00").format(date));
////            Long toTs = Safe.getTimestamp(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(date));
////            it.from(fromTs);
////            it.to(toTs);
////            it.limit(0);
//
//
//            StringBuffer req = new StringBuffer();
//            req.append("http://172.16.126.13/store/load?");
//            req.append("dataType=12");
//            req.append("&limit=0");
//            req.append("&sn=").append(sn);
//            Date date = new Date();
//            req.append("&from=").append(new SimpleDateFormat("yyyy-MM-dd%2000:00:00").format(date));
//            req.append("&to=").append(new SimpleDateFormat("yyyy-MM-dd%20HH:mm:ss").format(date));
//            log.info(req.toString());
//            HttpGet get = new HttpGet(req.toString());
//            httpEntity = HttpClients.createDefault().execute(get).getEntity();
//            String s = EntityUtils.toString(httpEntity);
//            List<String> dataList = new ArrayList<>();
//            if (!s.equals("")){
//                dataList = Arrays.asList(s.split("\n"));
//            }
//
//            Gson gson = new Gson();
//            for (String p : dataList) {
//                Map<String, Object> dataMap = new HashMap<>();
//                dataMap = gson.fromJson(p, dataMap.getClass());
//                Map<String, Object> info = (Map<String, Object>) dataMap.get("info");
//                Map<String, Object> ffBatteryStatus = (Map<String, Object>) dataMap.get("ffBatteryStatus");
//                if (ObjectUtils.isEmpty(info) || ObjectUtils.isEmpty(info.get("obdTime")) ||
//                        ObjectUtils.isEmpty(ffBatteryStatus) || ObjectUtils.isEmpty(ffBatteryStatus.get("cellVoltageList")) || ObjectUtils.isEmpty(ffBatteryStatus.get("cellTempList"))
//                        || ObjectUtils.isEmpty(ffBatteryStatus.get("soc")) || ObjectUtils.isEmpty(ffBatteryStatus.get("current"))) {
//                    continue; //如果数据有空的，则跳过该行数据
//                } else {
//                    timeList.add(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(info.get("obdTime")));
//                    List<Double> voltages = (List<Double>)ffBatteryStatus.get("cellVoltageList");
//                    voltageMaxList.add(Collections.max(voltages));
//                    voltageMinList.add(Collections.min(voltages));
//
//                    List<Double> temps =(List<Double>)ffBatteryStatus.get("cellTempList");
//                    tempMaxList.add(Collections.max(temps));
//                    tempMinList.add(Collections.min(temps));
//
//                    currentList.add(Double.parseDouble(ffBatteryStatus.get("current").toString()));
//                    socList.add(Double.parseDouble(ffBatteryStatus.get("soc").toString()));
//
//                }
//            }
//            rspBaseInfo.setCurrentList(currentList);
//            rspBaseInfo.setSocList(socList);
//            rspBaseInfo.setTempMaxList(tempMaxList);
//            rspBaseInfo.setTempMinList(tempMinList);
//            rspBaseInfo.setTimeList(timeList);
//            rspBaseInfo.setVoltageMaxList(voltageMaxList);
//            rspBaseInfo.setVoltageMinList(voltageMinList);
//            rspBaseInfo.setCode(200);
//            rspBaseInfo.setMessage("获取成功");
//        }
//        else{
//            rspBaseInfo.setCode(500);
//            rspBaseInfo.setMessage("未输入sn");
//        }
//
//
//        return rspBaseInfo;
//    }
//
//    @ApiOperation(value = "实时信息（位置信息，电池评分，瞬时信息)")
//    @RequestMapping(value = "/realtimeInfo", method = RequestMethod.GET)
//    public RspRealTimeInfo realtimeInfo(@ApiParam(name = "查询参数", value = "sn号", required = false) String sn) {
//        RspRealTimeInfo rspRealTimeInfo = new RspRealTimeInfo();
//
//        if (StringUtils.hasLength(sn)) {
//            String sql = "select t1.soh from soh_result t1  where " + "t1.sn='" + sn + "' order by time_st desc limit 1";
//            Map<String, Object> sohData;
//            try {
//                sohData = qxcasJdbcTemplate.queryForMap(sql);
//            } catch (EmptyResultDataAccessException e) {
//                sohData = null;
//            }
//
//            sql = "select t2.latitude, t2.longitude, t1.soh, t1.soc, t1.current, t1.charge_state, t1.error_level, " +
//                    "t1.cell_voltages, t1.max_temp, t1.min_temp, t1.other_temps from ff_battery_status t1 left join ff_location t2 on t1.devcode = t2.devcode where " +
//                    "t1.devcode='" + sn + "' limit 1";
//            Map<String, Object> lastData;
//            try {
//                lastData = iotpJdbcTemplate.queryForMap(sql);
//            } catch (EmptyResultDataAccessException e) {
//                lastData = null;
//            }
//            if (!ObjectUtils.isEmpty(lastData)) {
//                rspRealTimeInfo.setLatitude(Double.parseDouble(lastData.get("latitude").toString()));
//                rspRealTimeInfo.setLongitude(Double.parseDouble(lastData.get("longitude").toString()));
//
//                rspRealTimeInfo.setSoc(lastData.get("soc").toString());
//                List<String> voltages = Arrays.asList(((String) lastData.get("cell_voltages")).split(","));
//                rspRealTimeInfo.setMaxVolt(Collections.max(voltages));
//                rspRealTimeInfo.setCurrent(lastData.get("current").toString());
//                rspRealTimeInfo.setMinVolt(Collections.min(voltages));
//                Double score;
//                Double soh = sohData == null? Double.parseDouble(lastData.get("soh").toString()):Double.parseDouble(sohData.get("soh").toString());
//
//                lastData.put("error_level", lastData.get("error_level")==null? 0:lastData.get("error_level"));
//                score = (soh * soh * 14.0 / 100.0 + (4 - (Integer) lastData.get("error_level") * 24 * 5) + 1 * 100 * 0.1
//                        + (((300 - (Double.parseDouble(Collections.max(voltages)) - (Double.parseDouble(Collections.min(voltages))))) / 3) *
//                        ((300 - (Double.parseDouble(Collections.max(voltages)) - (Double.parseDouble(Collections.min(voltages))))) / 3) * 6 / 100)) / 25;
//
//                rspRealTimeInfo.setScore(score.toString());
//                if (((Integer) lastData.get("charge_state")).equals(0)) {
//                    rspRealTimeInfo.setStatus("静置");
//                }
//                if (((Integer) lastData.get("charge_state")).equals(1)) {
//                    rspRealTimeInfo.setStatus("快充");
//                }
//                if (((Integer) lastData.get("charge_state")).equals(2)) {
//                    rspRealTimeInfo.setStatus("慢充");
//                }
//                if (((Integer) lastData.get("charge_state")).equals(3)) {
//                    rspRealTimeInfo.setStatus("行车");
//                }
//                List<String> otherTemps = lastData.get("other_temps")==null? Arrays.asList("-"):Arrays.asList(((String) lastData.get("other_temps")).split(","));
//                rspRealTimeInfo.setConnectorTemp(otherTemps.get(0));
//                rspRealTimeInfo.setMaxTemp(lastData.get("max_temp").toString());
//                rspRealTimeInfo.setFaultLevel(lastData.get("error_level").toString());
//                rspRealTimeInfo.setMinTemp(lastData.get("min_temp").toString());
//
//                rspRealTimeInfo.setCode(200);
//                rspRealTimeInfo.setMessage("获取成功");
//
//            } else {
//                rspRealTimeInfo.setCode(500);
//                rspRealTimeInfo.setMessage("未查询到实时数据");
//            }
//        }
//        else{
//            rspRealTimeInfo.setCode(500);
//            rspRealTimeInfo.setMessage("未输入sn");
//        }
//
//        return rspRealTimeInfo;
//    }
//
//    @ApiOperation(value = "健康监控")
//    @RequestMapping(value = "/healthInfo", method = RequestMethod.GET)
//    public RspHealthInfo healthInfo(@ApiParam(name = "查询参数", value = "sn号", required = false) String sn) {
//        RspHealthInfo rspHealthInfo = new RspHealthInfo();
//
//        if (StringUtils.hasLength(sn)) {
//            String sql = "select t1.soh from soh_result t1  where " + "t1.sn='" + sn + "' order by time_st desc limit 1";
//            Map<String, Object> sohData;
//            try {
//                sohData = qxcasJdbcTemplate.queryForMap(sql);
//            } catch (EmptyResultDataAccessException e) {
//                sohData = null;
//            }
//            sql = "select t1.soh from ff_battery_status t1 where t1.devcode='" + sn + "' limit 1";
//            Map<String, Object> lastData;
//            try {
//                lastData = iotpJdbcTemplate.queryForMap(sql);
//            } catch (EmptyResultDataAccessException e) {
//                lastData = null;
//            }
//            if (!ObjectUtils.isEmpty(sohData) || !ObjectUtils.isEmpty(lastData)) {
//                Double soh = sohData == null ? Double.parseDouble(lastData.get("soh").toString()) : Double.parseDouble(sohData.get("soh").toString());
//                rspHealthInfo.setSoh(soh.toString());
//            }
//            else
//                rspHealthInfo.setSoh("-");
//
//
//            sql = "select cellsoc_diff from consistency_delta_soc where sn = '" + sn + "' order by time desc limit 1";
//            Map<String, Object> consisData;
//            try {
//                consisData = qxcasJdbcTemplate.queryForMap(sql);
//            } catch (EmptyResultDataAccessException e) {
//                consisData = null;
//            }
//            if (!ObjectUtils.isEmpty(consisData)) {
//                if (Double.parseDouble(consisData.get("cellsoc_diff").toString()) < 3) {
//                    rspHealthInfo.setConsistency("优");
//                } else if (Double.parseDouble(consisData.get("cellsoc_diff").toString()) >= 3 && Double.parseDouble(consisData.get("cellsoc_diff").toString()) < 6) {
//                    rspHealthInfo.setConsistency("良");
//                } else if (Double.parseDouble(consisData.get("cellsoc_diff").toString()) >= 6 && Double.parseDouble(consisData.get("cellsoc_diff").toString()) < 10) {
//                    rspHealthInfo.setConsistency("合格");
//                } else if (Double.parseDouble(consisData.get("cellsoc_diff").toString()) >= 10) {
//                    rspHealthInfo.setConsistency("差");
//                }
//            } else
//                rspHealthInfo.setConsistency("-");
//
//            rspHealthInfo.setAccumCycle("-");
//            rspHealthInfo.setAccumEnergy("-");
//            rspHealthInfo.setCode(200);
//            rspHealthInfo.setMessage("获取成功");
//        }
//        else{
//            rspHealthInfo.setCode(500);
//            rspHealthInfo.setMessage("未输入sn");
//        }
//        return rspHealthInfo;
//    }
//
//    @ApiOperation(value = "报警信息滚动")
//    @RequestMapping(value = "/allAlarmInfo", method = RequestMethod.GET)
//    public RspAllAlarmInfo allAlarmInfo() {
//        RspAllAlarmInfo rspAllAlarmInfo = new RspAllAlarmInfo();
//
//        String sql = "select t1.sn, t2.errName, t2.errLevel from fault_info t1 left join fid_info t2 on t1.fault_code=t2.errCode where t1.time > date_format(now(), '%Y-%m-%d')";
//        List<Map<String, Object>> faultData;
//        try {
//            faultData = qxcasJdbcTemplate.queryForList(sql);
//        } catch (EmptyResultDataAccessException e) {
//            faultData = null;
//        }
//        faultData.forEach(p -> {
//            AlarmMapDto alarmMap = new AlarmMapDto();
//            alarmMap.setInfo(p.get("errName") == null ? null : p.get("errName").toString());
//            alarmMap.setLevel(p.get("errLevel") == null ? null : p.get("errLevel").toString());
//            alarmMap.setSn(p.get("sn").toString());
//            rspAllAlarmInfo.getAlarmList().add(alarmMap);
//        });
//        rspAllAlarmInfo.setCode(200);
//        rspAllAlarmInfo.setMessage("获取成功");
//
//        return rspAllAlarmInfo;
//    }
//
//    @ApiOperation(value = "当前电池报警信息")
//    @RequestMapping(value = "/alarmInfo", method = RequestMethod.GET)
//    public RspAlarmInfo alarmInfo(@ApiParam(name = "查询参数", value = "sn号", required = false) String sn) {
//        RspAlarmInfo rspAlarmInfo = new RspAlarmInfo();
//
//        if (StringUtils.hasLength(sn)) {
//            String sql = "select t1.sn, t2.errName, t2.errLevel from fault_info t1 left join fid_info t2 on t1.fault_code=t2.errCode where " +
//                    "t1.sn='" + sn + "'";
//            List<Map<String, Object>> faultData;
//            try {
//                faultData = qxcasJdbcTemplate.queryForList(sql);
//            } catch (EmptyResultDataAccessException e) {
//                faultData = null;
//            }
//            if (!ObjectUtils.isEmpty(faultData)) {
//                faultData.forEach(p -> {
//                    AlarmMapDto alarmMap = new AlarmMapDto();
//                    alarmMap.setInfo(p.get("errName") == null ? null : p.get("errName").toString());
//                    alarmMap.setLevel(p.get("errLevel") == null ? null : p.get("errLevel").toString());
//                    alarmMap.setSn(p.get("sn").toString());
//                    rspAlarmInfo.getAlarmList().add(alarmMap);
//                });
//
//                sql = "select t1.u_id, t1.u_status, t2.username, t2.mobile from py_battery t1 left join py_users t2 on t1.u_id=t2.user_id where qrcode = '" + sn + "'";
//                Map<String, Object> userInfo;
//                try {
//                    userInfo = moyuJdbcTemplate.queryForMap(sql);
//                } catch (EmptyResultDataAccessException e) {
//                    userInfo = null;
//                }
//                if (userInfo != null && !userInfo.get("u_status").toString().equals("0")) {
//                    rspAlarmInfo.setUserName(userInfo.get("username").toString());
//                    rspAlarmInfo.setUserPhone(userInfo.get("mobile").toString());
//                }
//            }
//            rspAlarmInfo.setCode(200);
//            rspAlarmInfo.setMessage("获取成功");
//        }
//        else{
//            rspAlarmInfo.setCode(500);
//            rspAlarmInfo.setMessage("未输入sn");
//        }
//        return rspAlarmInfo;
//    }
//}
