package com.lm.lib.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel(value = "AlarmMap")
public class AlarmMapDto {
    @ApiModelProperty(
            value = "sn",
            name = "sn",
            dataType = "java.lang.String",
            accessMode = ApiModelProperty.AccessMode.READ_ONLY
    )
    protected String sn;

    @ApiModelProperty(
            value = "故障等级",
            name = "level",
            dataType = "java.lang.String",
            accessMode = ApiModelProperty.AccessMode.READ_ONLY
    )
    protected String level;

    @ApiModelProperty(
            value = "故障信息",
            name = "info",
            dataType = "java.lang.String",
            accessMode = ApiModelProperty.AccessMode.READ_ONLY
    )
    protected String info;

    @ApiModelProperty(
            value = "故障信息",
            name = "time",
            dataType = "java.lang.String",
            accessMode = ApiModelProperty.AccessMode.READ_ONLY
    )
    protected String time;


    @ApiModelProperty(
            value = "故障信息",
            name = "treatment",
            dataType = "java.lang.String",
            accessMode = ApiModelProperty.AccessMode.READ_ONLY
    )
    protected String treatment;
}
