package com.lm.lib.entity;

import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 *
 * </p>
 *
 * @author user
 * @since 2021-11-30
 */
@Data
@ApiModel(value="FfLocation对象", description="")
public class FfLocation {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "设备唯一ID，科易协议=UID")
    private String devcode;

    @ApiModelProperty(value = "定位状态：2=2d，3=3d，4=基站")
    private Integer locationType;

    @ApiModelProperty(value = "卫星数")
    private Integer satellites;

    @ApiModelProperty(value = "方向")
    private Integer direction;

    @ApiModelProperty(value = "海拔，米")
    private Integer altitude;

    @ApiModelProperty(value = "速度，km/h")
    private Double speed;

    @ApiModelProperty(value = "纬度")
    private Double latitude;

    @ApiModelProperty(value = "经度")
    private Double longitude;

    @ApiModelProperty(value = "GSM位置码LAC")
    private Integer lac;

    @ApiModelProperty(value = "GSM小区码Cell")
    private Integer cell;

    @ApiModelProperty(value = "定位时间")
    private LocalDateTime gpsTime;


}
